#include "LineGraph.h"
#include <QLabel>
#include <QVBoxLayout>
#include <QDebug>

LineGraph::LineGraph(QWidget *parent)
	: QWidget(parent)
{
	series = new QtCharts::QLineSeries();
    std::random_device rd;  //Will be used to obtain a seed for the random number engine
    std::mt19937 gen(rd()); //Standard mersenne_twister_engine seeded with rd()
    std::uniform_int_distribution<> dis(1, 100);

    for (int i = 0; i < 100; i++) {
        series->append(i, dis(gen));
    }
    //*series << QPointF(11, 1) << QPointF(13, 3) << QPointF(17, 6) << QPointF(18, 3) << QPointF(20, 2);
    QtCharts::QLineSeries* ser2 = new QtCharts::QLineSeries();

    for (int i = 0; i < 100; i++) {
        ser2->append(i, dis(gen));
    }
    chart = new QtCharts::QChart();
    chart->legend()->hide();
    chart->addSeries(series);
    chart->addSeries(ser2);
    chart->createDefaultAxes();
    chart->setTitle("Simple line chart example");
    chartView = new QtCharts::QChartView(chart);
    chartView->setRenderHint(QPainter::Antialiasing);
    //chartView->setMinimumSize(200, 200);
    QVBoxLayout* layout = new QVBoxLayout();
    layout->addWidget(chartView);
    this->setLayout(layout);

}

LineGraph::~LineGraph()
{
}

void LineGraph::mouseMoveEvent(QMouseEvent* event)
{
    qDebug() << "MouseMoveEvent";
}
