#pragma once
#include <string>
#include <vector>
#include <fstream>
#include <QPoint>
#include <map>

struct SolutionPointData {
public:
	int iteration;
	double objectiveFunction;
	int particleNumber;
};
class RunData
{
public:
	std::string name;
	std::string information;
	std::vector<SolutionPointData> solutionVec;
	RunData();
	RunData(std::string filePath);
	

	std::vector<QPointF> bestSolutionPerIteration;
	std::vector<QPointF> averageSolutionPerItertion;
	std::vector<QPointF> minSolutionPerItertion;
	std::vector<QPointF> maxSolutionPerItertion;
	std::vector<QPointF> dotsForDistribution;
	std::map<int, std::vector<QPointF>> particleMap;
private:
	bool badFileFlag = false;
	std::fstream fileStream;
	int actualLine = 0;
	void getLine(std::string& bufferString);

	void calculateBestAndAverageIter();
	void calculateParticleSolution();
	void calculateDotsForDistribution();

};

