#pragma once

#include <QtWidgets/QMainWindow>
#include "ui_metavis.h"
#include <QSettings>
#include <vector>
#include "RunData.h"
#include "CustomLineGraph.h"

/**
 * Main class of the GUI.
 */
class metavis : public QMainWindow
{
	Q_OBJECT

public:
	metavis(QWidget *parent = Q_NULLPTR);
	~metavis();
	CustomLineGraph* bestGraph;
	CustomLineGraph* particleGraph;
	CustomLineGraph* minMaxGraph;
private:
	Ui::metavisClass ui;
	QSettings* settings;
	std::vector<RunData> runVec;


private:
	/* Widget functions */
	void createChartWidget();
	void createWebEngineWidget();
	CustomLineGraph* createCustomWidget(QString titleString);


	/* Setting functions*/
	void writeActualMainWindowSettings();
	void readMainWindowSettings();


public slots:
	/**
	 * Opens the settingWindows Dialog.
	 */
	void openSetting();
	/**
	 * Open a logFile.	
	 */
	void openFile();
};
